var {classes: Cc, interfaces: Ci, utils: Cu} = Components;
const PREF_BRANCH = "extensions.old_search.";

Cu.import("resource://gre/modules/Services.jsm");

var sss = Cc["@mozilla.org/content/style-sheet-service;1"].getService(Ci.nsIStyleSheetService);
var ios = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
var uri = ios.newURI("chrome://old_search/content/overlay.css", null, null);
var urilin = null;
if (Services.appinfo.OS == "Linux")
    urilin = ios.newURI("chrome://old_search/content/overlay-lin.css", null, null);

function install() {}
function uninstall(aData, aReason) {
    if (aReason == ADDON_UNINSTALL) 
        Services.prefs.deleteBranch(PREF_BRANCH);
}

function startup(aData, aReason) {
    var branch = Services.prefs.getDefaultBranch(PREF_BRANCH);
    branch.setBoolPref("clear", false);
    branch.setIntPref("timeclear", 0);
    branch.setBoolPref("rightclear", false);
    branch.setBoolPref("middle", false);
    branch.setBoolPref("middle2", false);
    branch.setBoolPref("popupwidth", true);
    branch.setBoolPref("drop", false);
    branch.setBoolPref("engine", false);
    branch.setIntPref("timeengine", 0);
    if (aReason == ADDON_ENABLE || aReason == ADDON_INSTALL || aReason == ADDON_UPGRADE || aReason == ADDON_DOWNGRADE) {
        var windows = Services.wm.getEnumerator("navigator:browser");
        while (windows.hasMoreElements()) {
            try {
                var window = windows.getNext().QueryInterface(Ci.nsIDOMWindow);
                var list = window.document.querySelectorAll("searchbar"); 
                for (var f = 0; f < list.length; f++) {
                    try {
                        list[f].destroy();
                    } catch (e) { }
                }
            } catch (e) { }
        }
    }
    this.sss.loadAndRegisterSheet(this.uri, this.sss.AGENT_SHEET);
    if (this.urilin != null) 
        this.sss.loadAndRegisterSheet(this.urilin, this.sss.AGENT_SHEET);
}

function shutdown(aData, aReason) {
    if (aReason == APP_SHUTDOWN) 
        return;
    if (aReason == ADDON_DISABLE || aReason == ADDON_UPGRADE || aReason == ADDON_DOWNGRADE) {
        var windows = Services.wm.getEnumerator("navigator:browser");
        while (windows.hasMoreElements()) {
            try {
                var window = windows.getNext().QueryInterface(Ci.nsIDOMWindow);
                var list = window.document.querySelectorAll("searchbar"); 
                for (var f = 0; f < list.length; f++) {
                    try {
                        list[f].destroy();
                    } catch (e) { }
                }
            } catch (e) { }
        }
    }
    this.sss.unregisterSheet(this.uri, this.sss.AGENT_SHEET);
    if (this.urilin != null) 
        this.sss.unregisterSheet(this.urilin, this.sss.AGENT_SHEET);
}